{$apptype console}
(* printclip, Copyright (c) 2003 Jeremy English <jenglish@myself.com>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 *)
program printclip;

uses windows,clipbrd, dialogs, printers;

var
  print_diag : TPrintDialog;
  prnout : TextFile;

procedure get_clip_and_print;
begin
  AssignPrn(prnout);
  Rewrite(prnout);
  try
    clipboard.Open;
    if Clipboard.HasFormat(CF_TEXT) then
      Write(prnout, clipboard.astext)
    else
      writeln(prnout,'The Clipboard does not contain text');
    clipboard.close;
  finally
    CloseFile(prnout);
  end;
end;

begin
  print_diag := TPrintDialog.create(nil);
  try
    if print_diag.execute then
    begin
      get_clip_and_print;
    end;
  finally
    print_diag.free;
  end;
end.
